/* include gnu.gpl, (*) 2000 Micha 'malekith' Moskal <malekith@topnet.pl>. 
 * $Id: bot.h,v 1.5 2000/08/26 01:03:48 malekith Exp $ */

#include "config.h"
#include "lib.h"
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define NEW(a) (a*)xmalloc(sizeof(a))

#define CONF(a) (hsv("conf", a)->var_string)

/* sock.c */
void set_detach_password(const char *pass);
void drop_detach_info();
struct sockaddr;
char *show_addr(struct sockaddr *sin, int size);
void quit();

void send_colors();
void send_bools();

extern int listen_sock, client_sock;
extern char listen_password[];

/* socklist.c */
struct socket {
	struct socket *next;
	int fd;
	void *data;
	int (*handler)(int fd, void *data);
};
extern struct socket *sock_head;

void xsend(int cmd, const char *fmt, ...);
void xclose(int fd);
void link_listen_socket();
void sock_link(int beg, int fd, int (*handler) (int fd, void *data), 
	       void *data);


/* main.c */
void do_input(const char *win, const char *s);

/* colors.c */
char *line_do_compile(char *p, char *d);
int line_count_len(char *p);

/* window.h */
void win_sync(int n);
void win_add(const char *title);
void win_kill(const char *title);
void prt(const char *win, const char *string);
void prtf(const char *win, const char *fmt, ...)
	__attribute__ ((format(printf, 2, 3)));

/* irc.c */
int same(const char *n1, const char *n2);

/* init.c */
void init();
