/* include gnu.gpl, (*) 2000 Micha 'malekith' Moskal <malekith@topnet.pl>. 
 * $Id: main.c,v 1.4 2000/08/25 20:04:08 malekith Exp $ */

#include "bot.h"

#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>

void main_loop()
{
	struct socket *p, *tmp;
	fd_set rd;
	int x;
	
	for (;;) {
		x = 0;
		FD_ZERO(&rd);
		for (p = sock_head; p; p = p->next) {
			FD_SET(p->fd, &rd);
			if (p->fd > x)
				x = p->fd;
		}
		
		x = select(x + 1, &rd, 0, 0, 0);
		if (x == -1)
			continue;

		/* if sock->handler() returns non-zero, node needs to
		 * be unlinked and socket needs to be closed 
		 * these 2 loops does on-the-fly unlinking */
		while (sock_head && FD_ISSET(sock_head->fd, &rd))
			if (FD_ISSET(sock_head->fd, &rd)
			    && sock_head->handler(sock_head->fd, 
			    			  sock_head->data)) {
				p = sock_head;
				sock_head = sock_head->next;
				close(p->fd);
				xfree(p);
			} else
				break;
				
		p = sock_head;
		while (p && p->next)
			if (FD_ISSET(p->next->fd, &rd) 
			    && p->next->handler(p->next->fd, p->next->data)) {
				tmp = p->next;
				p->next = p->next->next;
				close(tmp->fd);
				xfree(tmp);
			} else
				p = p->next;

	}
}

int main()
{
	if (fork())
		exit(0);
		
	init();
	main_loop();
	return 0;
}
