/* include gnu.gpl, (*) 2000 Micha 'malekith' Moskal <malekith@topnet.pl>. 
 * $Id: common.h,v 1.4 2000/08/04 21:28:14 malekith Exp $ */

#ifndef _SCHIZA_COMMON_H
#define _SCHIZA_COMMON_H 1

#include "config.h"
#include "lib.h"
#include "script_ext.h"

#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>

/* parser -> */

/* vm -> */


/* common ... */
enum {
ID_ERROR,
/* constans */
ID_INT,		/* number */
ID_STRING,	/* name */
/* */
ID_VAR,		/* name */
ID_PROC,	/* name, right is the caption, left are args (ID_DEF_*'s) */
ID_CPROC,	/* number (no of proc), left args */
ID_CALL,	/* name, left=args */
/* var types (args and local vars) */
ID_DEF_INT,	/* name, caption: left -> initial expression */
ID_DEF_STRING,	/* name, caption: left -> initial expression */
ID_DEF_PTR,	/* name, caption: left -> initial expression */
ID_DEF_IHASH,	/* name. */
ID_DEF_PHASH,	/* name. */
ID_DEF_SHASH,	/* name. */
/* flow ctrl */
ID_IF,		/* top = condition, left,right - then,else */
ID_WHILE,	/* top = condition, left - body */
ID_BREAK,	/* left (will break (left) result loops) */
ID_DO_WHILE,
ID_CONTINUE,	/* left */
ID_RETURN,	/* left = a value to return */
ID_WALK,	/* left - block, name - hash name */
/* expressions */
ID_EXPR2,	/* left (operator in number) right,
		 * left & right can be either: 
		 * ID_{INT,STRING,VAR,CALL,EXPR{2,1}} 
		 * number: +, -, *, /, E(==),<, L(<=), >, M(>=), N(!=),
		 * z(<<), x(<<), |, &, a(&&), o(||), %, =, ^
		 */
ID_EXPR1,	/* one arg expr. same, only left is used,
		 * number: -,+,!,m(VAR--),M(--VAR),p(VAR++),P(++VAR),~ */
ID_HASH,	/* a hash member request, name is hash name, left is member */
ID_REGEXP,	/* top is of type (struct regexp *) */
ID_LAST
};

char *op2_name(int);
char *id_name(int id);

#endif /* _SCHIZA_COMMON_H */
