/* include gnu.gpl, (*) 2000 Micha 'malekith' Moskal <malekith@topnet.pl>. 
 * $Id: proc.h,v 1.4 2000/08/05 20:19:51 malekith Exp $ */

#ifndef _SCHIZA_PROC_H
#define _SCHIZA_PROC_H 1

#include "var.h"

struct frame;

typedef var *(*cproc)(struct frame *f);

struct proc {
	struct proc *next;
	char *name;
	
	byte *args, *body;
	void *cproc;
};

struct token;
struct frame;

void add_proc(struct frame * f, struct proc *p);
void free_proc(var *p);	/* this is in reality a (struct proc *p) */
struct proc *make_proc(struct token *args, struct token *body, const char *s);

/* cproc stuff */
struct proc *find_cproc(const char *name, u32 h);
var *exec_cproc(struct proc *p, struct frame *f);

void init_cprocs();

void add_cproc(const char *name, const char *proto, cproc exec);
char *getsarg(struct frame *f, const char *name);
int getiarg(struct frame *f, const char *name);

byte *bc_make_arg_list(const char *s);

#endif /* _SCHIZA_PROC_H */
