/* include gnu.gpl, (*) 2000 Micha 'malekith' Moskal <malekith@topnet.pl>. 
 * $Id: var.h,v 1.5 2000/08/05 20:19:51 malekith Exp $ */

#ifndef _SCHIZA_VAR_H
#define _SCHIZA_VAR_H 1

#define var_int		var_u.vint.val
#define var_string	var_u.vstring.val
#define var_string_size var_u.vstring.size
#define var_ptr		var_u.vptr.val

typedef struct var {
	struct var *next;
	char *name;
	
	union {
		struct {
			char *val;
			int size;
		} vstring;
		struct {
			int val;
		} vint;
		struct {
			void *val;
		} vptr;
	} var_u;
	
	unsigned int what:4;
	unsigned int lval:1;
} var;


enum {
V_VOID,
V_STRING,
V_INT,
V_PTR,
V_AD,
};

typedef struct hash {
	struct hash *next;
	char *name;
	var **entries;
	int size, num_entries;
	int type;
	
	void (*free_entry)(var *p);
} hash;

/* hash.c */
void hash_add(hash *h, var *p);
var *hash_find_ex(hash *h, const unsigned char *key);
var *hash_find_ex2(hash *h, const unsigned char *key, u32 x);
hash *hash_new(int type);
/* kill one hash */
void hash_kill_one(hash *h);
u32 xhash(const unsigned char *key);
int hash_del(hash * h, const char *key);

/* var.c */
	/* only release ptrs */
void kill_var(var *v);
	/* also free v */
void free_var(var *v);
var *new_iv(const char *name, int val);
var *new_sv(const char *name, const char *str);
var *new_pv(const char *name, void *ptr);
var *new_adv(char *target);
var *new_svn(const char *name, int n);
var *copy(const var *src);
void set_sv(var *v, const char *val);
void set_iv(var *v, int val);

struct frame;

var *fhv(struct frame *f, const char *h, const char *v, int type);

/* iface for global vars for outside apps: */
var *sv(const char *name);
var *iv(const char *name);
var *hsv(const char *h, const char *v);
var *hv(const char *h, const char *v);

#endif _SCHIZA_VAR_H
